chiark / gitweb /
Test suite: Provide tests which check that all our various build operations run the...
authorIan Jackson <ijackson@chiark.greenend.org.uk>
Mon, 27 Jul 2015 12:16:14 +0000 (13:16 +0100)
committerIan Jackson <ijackson@chiark.greenend.org.uk>
Mon, 27 Jul 2015 12:16:14 +0000 (13:16 +0100)
debian/changelog
tests/lib-build-modes [new file with mode: 0644]
tests/lib-restricts
tests/tests/build-modes [new file with mode: 0755]
tests/tests/build-modes-gbp [new file with mode: 0755]
tests/tests/build-modes-sbuild [new file with mode: 0755]

index 7e17a8f..bd5ab63 100644 (file)
@@ -63,6 +63,10 @@ dgit (1.1~~) unstable; urgency=low
     pass -nc.
   * Also suppress spurious runs of the clean target when building using
     git-buildpackage.
+  * Test suite: Provide tests which check that all our various build
+    operations run the right targets as expected (ie, that we are massaging
+    the arguments to dpkg-buildpackage, and suppressing our clean target,
+    etc., correctly).
 
  --
 
diff --git a/tests/lib-build-modes b/tests/lib-build-modes
new file mode 100644 (file)
index 0000000..836d1ec
--- /dev/null
@@ -0,0 +1,155 @@
+
+bm-prep () {
+       t-tstunt-parsechangelog
+
+       t-prep-newpackage example 1.0
+
+       cd $p
+
+       git checkout -b bad-build-deps indep-arch
+       perl -pe 's/Build-Depends.*/$&, x-dgit-no-such-package/' \
+               -i debian/control
+       git commit -a -m bad-build-deps
+
+       cat <<'END' >$tmp/stunt-git
+#!/bin/sh -e
+case "$*" in
+*clean*) echo >&2 "BUILD-MODES PROGRAM git $*" ;;
+esac
+exec git "$@"
+END
+       chmod +x $tmp/stunt-git
+
+       counter=0
+
+       if zgrep 'dpkg-buildpackage: Make dependency checks fatal for -S' \
+               /usr/share/doc/dpkg-dev/changelog.gz; then
+                       dpkgbuildpackage_deps_for_clean=true
+       else
+                       dpkgbuildpackage_deps_for_clean=false
+       fi
+}
+
+bm-guess-e-source-e-targets () {
+       local some_act=$1
+       case "$some_act" in
+       *" -b") e_source=false; e_targets='build binary'                ;;
+       *" -B") e_source=false; e_targets='build-arch binary-arch'      ;;
+       *" -A") e_source=false; e_targets='build-indep binary-indep'    ;;
+       *" -S") e_source=true;  e_targets=' '                           ;;
+       *" -F") e_source=true;  e_targets='build binary'                ;;
+       *)      e_source=true;  e_targets='build binary'                ;;
+       esac
+}
+
+
+bm-report-source () {
+       if "$@"; then
+               echo >&4 "SOURCE EXISTS"
+       else
+               echo >&4 "SOURCE MISSING"
+       fi
+}
+
+bm-build-deps-ok () {
+       case "$branch" in
+       indep-arch)             return 0        ;;
+       bad-build-deps)         return 1        ;;
+       esac
+}
+
+bm-compute-expected () {
+       require_fail=unexpect # or required
+       tolerate_fail=unexpect # or tolerate
+
+       exec 4>$bmexp
+       echo >&4 "$heading"
+
+       case $cleanmode in
+       git)            echo >&4 'BUILD-MODES PROGRAM git clean -xdf' ;;
+       git-ff)         echo >&4 'BUILD-MODES PROGRAM git clean -xdff' ;;
+       check)          echo >&4 'BUILD-MODES PROGRAM git clean -xdn' ;;
+       dpkg-source-d)  echo >&4 "EXAMPLE RULES TARGET clean" ;;
+       dpkg-source)    bm-build-deps-ok || tolerate_fail=tolerate
+                       echo >&4 "EXAMPLE RULES TARGET clean"
+                       ;;
+       none)           ;;
+       *)              fail "t-compute-expected-run $cleanmode ??" ;;
+       esac
+
+       if [ "x$e_targets" != x ]; then
+               # e_targets can be " " to mean `/may/ fail due to b-d'
+               bm-build-deps-ok || tolerate_fail=tolerate
+       fi
+
+       for t in $e_targets; do
+               bm-build-deps-ok || require_fail=required
+               echo >&4 "EXAMPLE RULES TARGET $t"
+       done
+
+       bm-report-source $e_source
+
+       exec 4>&-
+}
+
+bm-run-one () {
+       local args="--clean=$cleanmode $real_act"
+
+       heading="===== [$counter $branch $cleanmode $act] dgit $args ====="
+
+       bmlog=$tmp/run-$counter-output
+       bmexp=$tmp/run-$counter-expected
+       bmgot=$tmp/run-$counter-results
+
+       bm-compute-expected
+
+       git checkout $branch
+
+       dsc='../example_1.0.dsc'
+       rm -f $dsc
+
+       set +o pipefail
+       t-dgit --git=$tmp/stunt-git $args 2>&1 | tee $bmlog
+       local ps="${PIPESTATUS[*]}"
+       set -o pipefail
+
+       $bm_quirk_after_act
+
+       exec 4>$bmgot
+       echo >&4 "$heading"
+
+       case $ps in
+       "0 0")  actual_status=success ;;
+       *" 0")  actual_status=failure; echo >&4 "OPERATION FAILED"; ;;
+       *)      fail "tee failed" ;;
+       esac
+
+       case "$require_fail-$tolerate_fail-$actual_status" in
+       required-********-failure) echo >>$bmexp "REQUIRED FAILURE" ;;
+       ********-tolerate-failure) echo >>$bmexp "TOLERATED FAILURE" ;;
+       unexpect-********-success) ;;
+       *)      fail "RF=$require_fail TF=$tolerate_fail AS=$actual_status" ;;
+       esac
+
+       egrep >&4 '^EXAMPLE RULES TARGET|^BUILD-MODES' $bmlog || [ $? = 1 ]
+
+       bm-report-source [ -e $dsc ]
+
+       exec 4>&-
+
+       $bm_quirk_before_diff
+
+       [ $actual_status = failure ] || diff -U10 $bmexp $bmgot
+
+       counter=$(( $counter + 1 ))
+}
+
+bm-act-iterate () {
+       for cleanmode in git none dpkg-source dpkg-source-d; do
+       # git-ff check removed because they're really very similar
+               for branch in indep-arch bad-build-deps; do
+                       bm-run-one
+               done
+       done
+       : bm-act-iterate done.
+}
index aca6692..ee5902c 100644 (file)
@@ -11,3 +11,7 @@ t-restriction-x-dgit-git-only () {
        echo 'not running out of git clone'
        return 1
 }
+
+t-restriction-x-dgit-schroot-build () {
+       schroot -la | grep -xF chroot:build
+}
diff --git a/tests/tests/build-modes b/tests/tests/build-modes
new file mode 100755 (executable)
index 0000000..f01bc99
--- /dev/null
@@ -0,0 +1,28 @@
+#!/bin/bash
+set -e
+. tests/lib
+. $troot/lib-build-modes
+
+bm-prep
+
+for act in                                     \
+       'build'                                 \
+       'build -S'                              \
+       'build -b'                              \
+       'build -B'                              \
+       'build -A'                              \
+       'build -F'                              \
+       build-source                            \
+; do
+       bm-guess-e-source-e-targets "$act"
+
+       case $act in
+       build-source)   e_source=true;  e_targets=''                    ;;
+       esac
+
+       real_act="$act"
+
+       bm-act-iterate
+done
+
+echo ok.
diff --git a/tests/tests/build-modes-gbp b/tests/tests/build-modes-gbp
new file mode 100755 (executable)
index 0000000..938e589
--- /dev/null
@@ -0,0 +1,37 @@
+#!/bin/bash
+set -e
+. tests/lib
+. $troot/lib-build-modes
+
+t-dependencies git-buildpackage
+
+quirk-clean-fixup () {
+       case $cleanmode in
+       dpkg-source*)
+               # git-buildpackage runs the clean target twice somehow
+               perl -i.unfixed -ne '
+                       print unless
+                               $_ eq $last &&
+                               $_ eq "EXAMPLE RULES TARGET clean\n";
+                       $last = $_;
+               ' $bmgot
+               ;;
+       esac
+}
+bm_quirk_before_diff=quirk-clean-fixup
+
+bm-prep
+
+for act in                                     \
+       'git-build -S'                          \
+       'git-build -b'                          \
+       'git-build -B'                          \
+       'git-build -A'                          \
+       'git-build -F'                          \
+; do
+       bm-guess-e-source-e-targets "$act"
+       real_act="$act --git-ignore-branch"
+       bm-act-iterate
+done
+
+echo ok.
diff --git a/tests/tests/build-modes-sbuild b/tests/tests/build-modes-sbuild
new file mode 100755 (executable)
index 0000000..826c467
--- /dev/null
@@ -0,0 +1,33 @@
+#!/bin/bash
+set -e
+. tests/lib
+. $troot/lib-build-modes
+
+t-dependencies sbuild
+t-restrict x-dgit-schroot-build
+
+arch=$(dpkg-architecture -qDEB_BUILD_ARCH)
+after-hook () {
+       # sbuild likes to run the package clean target in the chroot,
+       # which isn't necessary in our case.  We don't disable it in
+       # dgit because we want to do what sbuild does, in case there
+       # are packages which don't build unless their clean target was
+       # run.  We know it must be running it in the chroot because we
+       # provide sbuild with the dsc, not the tree, so we simply
+       # ignore all executions of the clean target by schroot.
+       sed '
+               s/^EXAMPLE RULES TARGET clean/HOOK SUPPRESSED &/;
+       ' ../example_1.0_$arch.build >>$bmlog
+}
+bm_quirk_after_act=after-hook
+
+bm-prep
+
+act="sbuild -c build"
+real_act="$act --no-arch-all"
+
+e_source=true
+e_targets='build-arch binary-arch'
+bm-act-iterate
+
+echo ok.